///////////////////////////
//Prepare regulation data
///////////////////////////

//Set working directory
cd "YOUR DIRECTORY"

import excel "EFWdataset2017.xlsx", sheet("Regulation") firstrow clear

//Manipulate regulation data
rename Countries nation
replace nation = "el" if nation == "Greece"
replace nation = "uk" if nation == "United Kingdom"
replace nation = "es" if nation == "Spain"
replace nation = "de" if nation == "Germany"
replace nation = "mt" if nation == "Malta"
replace nation = "bu" if nation == "Bulgaria"
replace nation = "at" if nation == "Austria"
replace nation = "be" if nation == "Belgium"
replace nation = "cy" if nation == "Cyprus"
replace nation = "cz" if nation == "Czech Rep."
replace nation = "dk" if nation == "Denmark"
replace nation = "ee" if nation == "Estonia"
replace nation = "fi" if nation == "Finland"
replace nation = "fr" if nation == "France"
replace nation = "hu" if nation == "Hungary"
replace nation = "ie" if nation == "Ireland"
replace nation = "it" if nation == "Italy"
replace nation = "lv" if nation == "Latvia"
replace nation = "lt" if nation == "Lithuania"
replace nation = "lu" if nation == "Luxembourg"
replace nation = "nl" if nation == "Netherlands"
replace nation = "pl" if nation == "Poland"
replace nation = "pt" if nation == "Portugal"
replace nation = "ro" if nation == "Romania"
replace nation = "si" if nation == "Slovenia"
replace nation = "sk" if nation == "Slovak Rep"
replace nation = "se" if nation == "Sweden"
replace nation = "hr" if nation == "Croatia"

//Fill in observations with linear interpolation
encode nation, gen(nat)
tsset nat year
tsfill
sort nat year
replace regulation = regulation[_n-1] + (((regulation[_n+4]-regulation[_n-1])/4)*1) if year == 1996
replace regulation = regulation[_n-1] + (regulation[_n-1]-regulation[_n-2]) if year == 1997
replace regulation = regulation[_n-1] + (regulation[_n-1]-regulation[_n-2]) if year == 1998
replace regulation = regulation[_n-1] + (regulation[_n-1]-regulation[_n-2]) if year == 1999
decode nat, gen(nat1)
replace nation = nat1
drop nat
drop nat1

rename regulation regul_strength
rename nation government

//Label variables
label variable government "Government"
label variable year "Year"
label variable regul_strength "Regulatory Strenth (Fraser Institute), interpolated"

//Save
save "regulation_data.dta", replace
